var valorTipoIdent="";
//Datos Webservice
var tipoIdent = $("#paciente_madrepcte_persona_cttipoidentificacion");
var numeroIdent = $("#paciente_madrepcte_persona_numeroidentificacion");
var primerApell = $("#paciente_madrepcte_persona_apellidopaterno");
var segundoApell = $("#paciente_madrepcte_persona_apellidomaterno");
var primerNom = $("#paciente_madrepcte_persona_primernombre");
var segundoNom = $("#paciente_madrepcte_persona_segundonombre");
var estcivil = $("#paciente_madrepcte_persona_ctestadocivil");
var sexoMadre = $("#paciente_madrepcte_persona_ctsexo");

//Datos Adicionales
var numtelefono = $("#paciente_madrepcte_numerotelefonico");
var dirdomicilio = $("#paciente_madrepcte_direcciondomicilio");
var nivelinstruccion = $("#paciente_madrepcte_persona_ctniveleducacion");
var autoidentetnica = $("#paciente_madrepcte_ctetnia");
var recibebono = $("#paciente_madrepcte_recibebono");
var madreparentesco = $("#paciente_ctparentescomadre");

//Datos Nacimiento
var paisNac = $("#paciente_madrepcte_persona_pais");
var provinciaNac = $("#paciente_madrepcte_persona_provincia");
var cantonNac = $("#paciente_madrepcte_persona_canton");
var parroquiaNac = $("#paciente_madrepcte_persona_parroquia");
var lugarNac = $("#paciente_madrepcte_persona_lugarnacimiento");
var fechaNac = $("#paciente_madrepcte_persona_fechanacimiento");




//Otras variables
var mode = "{{ modo }}";
var madrepersona_id = parseInt("{{ madrepersona_id }}");
var cantonnac_id = "", parroquianac_id = "";
var existe_madrepcte = false;
var responsewsregistrocivil = false;
var isWS = false;
var esExtranjero = false;
load = (mode == "EDITAR") ? true : false;

var validador = null;

$(function (){

    keyupCI();
    keyupNumeroIdent();
    changeNacionalidad();
    onchangeTipoIdentif();
    onchangeNumeroIdent();
    fillLugarNacimiento();

    {#$("#formPaciente").initInputsForm().validationForm();#}

    /*Combos cascacadas */
    cantonNac.cascadeCombobox({
        parents_id: 'paciente_madrepcte_persona_provincia',
        urlLoad: "{{ path('hcue_paciente_paciente_cantoncombobox') }}",
        onLoad: function () {
            cantonNac.val(cantonnac_id).trigger("chosen:updated");
        }
    });
    parroquiaNac.cascadeCombobox({
        parents_id: 'paciente_madrepcte_persona_canton',
        urlLoad: "{{ path('hcue_paciente_paciente_parroquiacombobox') }}",
        onLoad: function () {
            parroquiaNac.val(parroquianac_id).trigger("chosen:updated")
        }
    });

    if (mode == "EDITAR") {
        load = true;
        enableFields(false);
        if (paisNac.val() == parseInt('{{ NACIONALIDAD_ECUATORIANA }}') && provinciaNacimiento.val() == '') {
            esExtranjero = true;
        }

        if (tipoIdent.val() == parseInt('{{ TIPOIDENTCEDULA }}') && parseInt('{{ foto_id }}') == 0) {
            loadFoto();
        }
    }

    //obtener los datos de residencia del paciente
    $('#tabpcte a, #tabpcteadd a').click(function(){
        var objmadrepcte_direcciondomicilio=$("#paciente_madrepcte_direcciondomicilio");
        var objmadrepcte_numerotelefonico=$("#paciente_madrepcte_numerotelefonico");
        var menu=$(this).attr("href");
        if(menu=="#menu6"){
            if(!objmadrepcte_direcciondomicilio.val()){
                var resi_calleprincipal=$("#paciente_calleprincipal").val();
                var paciente_numero=$("#paciente_numero").val();
                var paciente_callesecundaria=$("#paciente_callesecundaria").val();
                var direccion = resi_calleprincipal+" "+paciente_numero+" "+paciente_callesecundaria;
                $("#paciente_madrepcte_direcciondomicilio").val(direccion);
            }

            if(!objmadrepcte_numerotelefonico.val()){
                var paciente_celular=$("#paciente_celular").val();
                var paciente_telefono=$("#paciente_tedisabledlefono").val();
                var telefono;
                if(paciente_celular){
                    telefono = paciente_celular.replace(/\D/g,'');
                }else{
                    telefono =(paciente_telefono)? paciente_telefono.replace(/\D/g,''):"";
                }
                $("#paciente_madrepcte_numerotelefonico").val(telefono);
            }
        }
    });

    primerApell.blur(function () {
        if ($(this).valid()) {
            activaBusquedaNoIdentificado();
        }
    });
    {#segundoApell.blur(function () {
       activaBusquedaNoIdentificado();
    });#}
    primerNom.blur(function () {
        if ($(this).valid()) {
            activaBusquedaNoIdentificado();
        }
    });
    {#segundoNom.blur(function () {
        activaBusquedaNoIdentificado();
    });#}
    fechaNac.blur(function () {
        if ($(this).valid()) {
            activaBusquedaNoIdentificado();
        }
    });
    paisNac.on('change', function () {
        activaBusquedaNoIdentificado();
    });
    provinciaNac.on('change', function () {
        activaBusquedaNoIdentificado();
    });
});

function activaBusquedaNoIdentificado() {
    if (tipoIdent.val() == parseInt('{{ TIPOIDENTNOIDENTIFICADO }}')) {
        if (primerApell.val()!="" && primerNom.val()!="" && fechaNac.val()!="" && paisNac.val()!="") {
            if (paisNac.val() == parseInt('{{ NACIONALIDAD_ECUATORIANA }}')) {
                if (provinciaNac.val()!="") {
                    buscarNoIdentificado();
                }
            } else {
                buscarNoIdentificado();
            }
        }
    }
}

function buscarNoIdentificado() {
    var tipo_iden = tipoIdent.val();
    var primer_ape = primerApell.val();
    var segundo_ape = segundoApell.val() ? segundoApell.val() : 0;
    var primer_nom = primerNom.val();
    var segundo_nom = segundoNom.val() ? segundoNom.val() : 0;
    var fecha_nac = fechaNac.val();
    var pais_nac = paisNac.val();
    var prov_nac = provinciaNac.val() ? provinciaNac.val() : 0;

    $.processWait.show();
    $.ajax({
        type: 'POST',
        dataType: 'json',
        async: false,
        url: "{{ path('hcue_paciente_paciente_buscarnoidentificado') }}/" + tipo_iden + "/" + primer_ape + "/" + segundo_ape + "/" + primer_nom + "/" + segundo_nom + "/" + fecha_nac + "/" + pais_nac + "/" + prov_nac,
        success: function (data) {
            if(data){
                $('#paciente_madrepcte_persona_madre_paciente_id').val("");
                $.confirm("Esta persona ya se encuentra registrado con la siguiente información: <br/><br/><strong>Código: </strong>" + data.numeroidentificacion + "<br/><strong>Nombres y Apellidos: </strong>" + data.nombrecompleto + "<br/><strong>Fecha de nacimiento: </strong>" + data.fechanacimiento + "<br/><strong>Nacionalidad: </strong>" + data.nacionalidad +"<br/><br/><strong>Desea usar los datos de esta persona para registrar el paciente?</strong><br/><br/><strong>Nota: </strong>En caso de NO coincidir esta información por favor alterne la información de los nombres", function (result) {
                    if (result) {
                        $('#paciente_madrepcte_persona_madre_paciente_id').val(data.id);
                    }
                });
            }
        }
    }).done(function(){
        $.processWait.hide();
    });
}

function loadData(){
    if (numeroIdent.valid()) {
        var value = numeroIdent.val();
        wsregcivil(value);
    }
}

function reloadData(){
    var madrepct_id=$("#paciente_madrepcte_persona_numeroidentificacion").val();
    existeMadrepcte(madrepct_id);
}

function existeMadrepcte(identificacion) {
   var paciente_identificacion=$.trim($("#paciente_persona_numeroidentificacion").val());

    if (identificacion.length == 0 || identificacion == undefined)
        return;

    if(identificacion==paciente_identificacion){
        $.alert("El representante debe ser distinto que el paciente");
        return;
    }
    $.processWait.show();
    $.ajax({
        type: 'GET',
        dataType: 'json',
        async: false,
        url: "{{ path('hcue_paciente_paciente_existmadrepcte') }}/" + identificacion + "/" + parseInt("{{ madrepersona_id }}"),
        success: function (data) {
            clearFieldsWebservice();
            clearVariables();
            if(data.length){
                $.gritter.add({ title: 'Información!', text: "Obteniendo información desde el PRAS",time: 2000, class_name: 'gritter-info gritter-light' });
                setDataMadrepctPersona(data[0]);
            }
            else{

                if (tipoIdent.val() == parseInt('{{ TIPOIDENTCEDULA }}')) {
                    $.gritter.add({ title: 'Información!', text: "Obteniendo información desde el Registro Civil",time: 2000, class_name: 'gritter-info gritter-light' });
                    loadData();
                }else{
                    enableFields(false);
                    enableFieldsWS(false);
                    enableLocationNacimiento(false);
                }
            }
            if (tipoIdent.val() == parseInt('{{ TIPOIDENTCEDULA }}')) {
                loadFoto();
            }
        }
    }).done(function(){
        $.processWait.hide();
    });
}

/*Valida el campo numero de identificacion deacuerdo a lo que se
     * escoja en tipo de identificación*/
function onchangeTipoIdentif() {
    tipoIdent.on("change", function () {
        var campos = true, noidentificado = false;
        responsewsregistrocivil = false;
        isWS = false;
        clearVariables();
        lugarNac.attr('disabled',true);

        if (valorTipoIdent == parseInt('{{ TIPOIDENTCEDULA }}')) {
            clearFieldsWebservice();
        }
        valorTipoIdent = $(this).val();
        if (valorTipoIdent == parseInt('{{ TIPOIDENTCEDULA }}')) {
            numeroIdent.removeClass("alphanumeric upper existe_paciente")
                .removeAttr("required minlength")
                .addClass("numeric cedula")
                .attr({"maxlength":'{{ MAXIMO_CARACTERES_NACIONAL }}', "disabled":false, "placeholder":"Número Identificación", "required":true})
                .val('');
        } else if (valorTipoIdent == parseInt('{{ TIPOIDENTNOIDENTIFICADO }}')) {
            numeroIdent.attr("placeholder", "Se genera automáticamente")
                .attr("disabled", true)
                .val('')
                .removeAttr("required")
                .removeClass("required existe_paciente")
                .removeClass("existe_madrepcte");
            responsewsregistrocivil = false;
            campos = false;
            noidentificado = true;
        } else if (valorTipoIdent > 0) {
            numeroIdent.removeClass("cedula existe_paciente")
                .removeClass("numeric")
                .addClass("upper")
                .addClass("alphanumeric")
                .attr("maxlength", '{{ MAXIMO_CARACTERES_EXTRANJERO }}')
                .attr("minlength", '{{ MINIMO_CARACTERES_EXTRANJERO }}')
                .attr("disabled", false)
                .attr("placeholder", "Número Identificación")
                .val('')
                .attr("required", "required");
        } else {
            numeroIdent
                .attr("disabled", true)
                .attr("placeholder", "Número Identificación")
                .val('')
                .attr("required", true);
        }

        numeroIdent.unbind().focus();

        if (mode == "AGREGAR" || ( mode == "EDITAR" )) {
            enableAll(campos);
            enableLocationNacimiento(campos, noidentificado);
        }
        onchangeNumeroIdent();
        keyupNumeroIdent();
        keyupCI();
        fillLugarNacimiento
    });
}

function onchangeNumeroIdent() {
    var paciente_identificacion=$("#paciente_persona_numeroidentificacion").val();

    numeroIdent.blur(function () {

        if ($(this).valid()) {
            $.processWait.show();
            existeMadrepcte($(this).val());
            $.processWait.hide();
        }
    });
}

function keyupCI() {
    numeroIdent.keyup(function () {
        if (tipoIdent.val() == parseInt('{{ TIPOIDENTCEDULA }}')) {
            if (numeroIdent.length < parseInt('{{ MAXIMO_CARACTERES_NACIONAL }}')) {
                clearFieldsWebservice();
                clearVariables();
            }
        }
    });
}

/*Habilita los campos necesarios */
function keyupNumeroIdent() {
    numeroIdent.keyup(function () {
        existe_madrepcte = false;
    });
}

function enableFieldsWS(boleano) {
    primerApell.attr("disabled", boleano);
    segundoApell.attr("disabled", boleano);
    primerNom.attr("disabled", boleano);
    segundoNom.attr("disabled", boleano);
    fechaNac.attr("disabled", boleano);
    sexoMadre.attr("disabled", boleano);
    paisNac.attr("disabled", boleano).trigger("chosen:updated");
    estcivil.attr("disabled", boleano);
}

function enableFields(boleano) {
    numtelefono.attr("disabled", boleano);
    dirdomicilio.attr("disabled", boleano);
    autoidentetnica.attr("disabled", boleano);
    nivelinstruccion.attr("disabled", boleano);
    madreparentesco.attr("disabled", boleano);
    recibebono.attr("disabled", boleano);
    if (validador) {
        validador.resetForm();
    }
    $(".has-error").removeClass("has-error");
}

function enableLocationNacimiento(boleano, noidentificado) {
    provinciaNac.attr("disabled", boleano).trigger("chosen:updated");
    cantonNac.attr("disabled", boleano).trigger("chosen:updated");
    parroquiaNac.attr("disabled", boleano).trigger("chosen:updated");
    lugarNac.val('');

    if (noidentificado) {
        provinciaNac.attr("required", "required").prev('label').append('<i style="color:red" class="asterisk">*</i>');
        cantonNac.attr("required", "required").prev('label').append('<i style="color:red" class="asterisk">*</i>');
        parroquiaNac.attr("required", "required").prev('label').append('<i style="color:red" class="asterisk">*</i>');
        paisNac.val('{{ NACIONALIDAD_ECUATORIANA }}').trigger("chosen:updated");
        lugarNac.prev('label').find('i').remove();
    }
    else {
        provinciaNac.removeAttr("required").prev('label').find('i').remove();
        cantonNac.removeAttr("required").prev('label').find('i').remove();
        parroquiaNac.removeAttr("required").prev('label').find('i').remove();
        paisNac.val('').trigger("chosen:updated");
        lugarNac.prev('label').find('i').replaceWith('<i style="color:red" class="asterisk">*</i>');
    }
}

/*Metodo que llena los valores devueltos por el webservis del registro civil*/
/**
 * @param data.condicioncedulado
 * @param data.webservis
 * @param data.apellidopaterno
 * @param data.apellidomaterno
 * @param data.primernombre
 * @param data.segundonombre
 * @param data.fechanacimiento
 * @param data.provincianacimiento
 * @param data.cantonnacimiento
 * @param data.parroquianacimiento
 * @param data.anormal
 * @param data.extranjero
 * @param data.disablednacionalidad
 * */
function wsregcivil(cedula) {
    var idIcono = numeroIdent;
    isWS = true;
    if (mode == "EDITAR") {
        idIcono = $("#webservice");
    }
    idIcono.after("<i id='load_webservice' class='fa fa-spinner fa-spin orange bigger-110' style='display:none'></i>");
    $.ajax({
        type: 'POST',
        dataType: 'json',
        async: false,
        url: "{{ path('hcue_paciente_paciente_wsregistrocivil') }}/" + cedula,
    }).done(function (json) {
        if (json.type != 'noexiste') {
            data = json.data;
            if (json.type == 'webservice') {
                if (data.condicioncedulado == "FALLECIDO") {
                    $.alert("La persona ya esta fallecida");
                }
                else {
                    enableFields(false);
                    responsewsregistrocivil = data.webservis;
                    if (responsewsregistrocivil) {
                        enableFieldsWS(true);
                        enableLocationNacimiento(true);
                    } else {
                        enableFieldsWS(false);
                        enableLocationNacimiento(false);
                    }

                    if (data.anormal) {
                        $.alert('Paciente con nombre compuesto, por favor verificar la información', 'info');
                        primerApell.removeAttr('disabled').val(data.nombrecompleto);
                        segundoApell.removeAttr('disabled').val('');
                        primerNom.removeAttr('disabled').val('');
                        segundoNom.removeAttr('disabled').val('');
                    }
                    else {
                        primerApell.attr('disabled', true).val(data.apellidopaterno);
                        segundoApell.attr('disabled', true).val(data.apellidomaterno);
                        primerNom.attr('disabled', true).val(data.primernombre);
                        segundoNom.attr('disabled', true).val(data.segundonombre);
                    }

                    fechaNac.val(data.fechanacimiento).change();
                    estcivil.val(data.estadocivil);
                    sexoMadre.val(data.sexo);
                    esExtranjero = data.extranjero;
                    paisNac.val(data.nacionalidad).attr('disabled', data.disablednacionalidad).trigger("chosen:updated").change(); //ECUATORIOANO
                    if (!esExtranjero) {
                        provinciaNac.val(data.provincianacimiento).trigger("chosen:updated").change();
                        cantonnac_id = data.cantonnacimiento;
                        parroquianac_id = data.parroquianacimiento;
                        if (data.provincianacimiento == "") {
                            provinciaNac.removeAttr("disabled")
                                .trigger("chosen:updated")
                                .attr("required", "required")
                                .prev('label').append('<i style="color:red" class="asterisk">*</i>');
                        }
                        if (cantonnac_id == "") {
                            cantonNac.removeAttr("disabled")
                                .trigger("chosen:updated")
                                .attr("required", "required")
                                .prev('label').append('<i style="color:red" class="asterisk">*</i>');
                        }
                        if (parroquianac_id == "") {
                            parroquiaNac.removeAttr("disabled")
                                .attr("required", "required")
                                .prev('label').append('<i style="color:red" class="asterisk">*</i>');

                        }
                    }
                    lugarNac.val(data.lugarnacimiento);
                    if ((data.lugarnacimiento.trim()) == "" || data.lugarnacimiento == undefined) {
                        lugarNac.removeAttr("disabled").val('');
                    }
                }
            }
        }
        else {
            responsewsregistrocivil = false;
            enableFieldsWS(false);
            if (mode == "AGREGAR") {
                enableLocationNacimiento(false);
            }
            enableFields(false);
        }
    });
}

function setDataMadrepctPersona(data) {
    enableFields(false);
    {#enableFieldsWS(false);#}
    enableLocationNacimiento(false);
    primerApell.attr('disabled', true).val(data.apellidopaterno);
    segundoApell.attr('disabled', true).val(data.apellidomaterno);
    primerNom.attr('disabled', true).val(data.primernombre);
    segundoNom.attr('disabled', true).val(data.segundonombre);
    fechaNac.val(data.fechanacimiento).change();
    estcivil.val(data.ctestadocivil_id);
    sexoMadre.val(data.ctsexo_id);

    paisNac.val(data.pais_id).trigger("chosen:updated").change();
    cantonnac_id = data.canton_id;
    parroquianac_id = data.parroquia_id;
    provincianac_id= data.provincia_id;
    if (provincianac_id) {
        provinciaNac.val(provincianac_id).trigger("chosen:updated").change();
        provinciaNac.attr("required", "required")
            .attr("disabled", true)
            .trigger("chosen:updated");
    }
    if (cantonnac_id) {
        cantonNac.attr("required", "required")
            .attr("disabled", true)
            .trigger("chosen:updated");
    }
    if (parroquianac_id) {
        parroquiaNac.attr("required", "required")
            .attr("disabled", true);
    }

    lugarNac.val(data.lugarnacimiento);
    if(!data.lugarnacimiento){
        lugarNac.removeAttr("disabled")
    }
}

function loadFoto() {
    if (tipoIdent.val() == parseInt('{{ TIPOIDENTCEDULA }}')) {
        var src = '{{ path('coreapp_archivo_fotoregistrocivil') }}/' + numeroIdent.val();
        $("#madrepcte_foto").attr("src", src);
    }
}

/*Si el paciente es Ecuatoriano abilita y validad que se ingresen los campos
     * provinvia, canton y parroquia de nacimiento*/
function changeNacionalidad() {
    paisNac.on('change', function () {
        var nacionalidad_ecuatoriana = parseInt('{{ NACIONALIDAD_ECUATORIANA }}');
        if ($(this).val() == nacionalidad_ecuatoriana && !esExtranjero && !responsewsregistrocivil) {
            $("#paciente_madrepcte_persona_provincia, #paciente_madrepcte_persona_canton, #paciente_madrepcte_persona_parroquia")
                .attr("required", "required").removeAttr("disabled").trigger("chosen:updated").prev('label').append('<i style="color:red" class="asterisk">*</i>');

            if($("#paciente_madrepcte_persona_parroquia").val()!="" && tipoIdent.val() == parseInt('{{ TIPOIDENTCEDULA }}')){
                $("#paciente_madrepcte_persona_provincia, #paciente_madrepcte_persona_canton, #paciente_madrepcte_persona_parroquia").attr("disabled", true);
            }

            autoidentetnica.removeAttr("disabled");
            lugarNac.attr("disabled", "true").prev('label').find('i').remove();
            if (!load) {
                autoidentetnica.val("");
                lugarNac.val("");
            }
            if (tipoIdent.val() != parseInt('{{ TIPOIDENTCEDULA }}') && !load) {
                $("#paciente_madrepcte_persona_provincia, #paciente_madrepcte_persona_canton, #paciente_madrepcte_persona_parroquia, #paciente_madrepcte_persona_lugarnacimiento")
                    .val("").trigger("chosen:updated");
            }
        } else if ($(this).val() != nacionalidad_ecuatoriana) {
            $("#paciente_madrepcte_persona_provincia, #paciente_madrepcte_persona_canton, #paciente_madrepcte_persona_parroquia")
                .removeAttr("required").attr("disabled", true).val("").trigger("chosen:updated").prev('label').find('i').remove();

            lugarNac.prev('label').find('i').remove();
            lugarNac.prev('label').append('<i style="color:red" class="asterisk">*</i>');
            if (tipoIdent.val() != parseInt('{{ TIPOIDENTCEDULA }}') && tipoIdent.val() != "" || !responsewsregistrocivil) {
                lugarNac.removeAttr("disabled");
                if (!load) {
                    lugarNac.val("");
                }
            }
            autoidentetnica.val('{{ ETNIA_NOAPLICA }}').attr("disabled", "true").change();
            if (validador) {
                autoidentetnica.valid()
            }
        }

        $("#paciente_madrepcte_persona_provincia, #paciente_madrepcte_persona_canton, #paciente_madrepcte_persona_parroquia").parents('div').removeClass("has-error").find('.help-block').remove();
    });
}

function getLugarNacimiento() {
    if (!responsewsregistrocivil) {
        var textprovincia = $("option:selected", provinciaNac).text().split(" ");
        var textcanton = $("option:selected", cantonNac).text().split(" ");
        var textparroquia = $("option:selected", parroquiaNac).text().split(" ");
        var resultado = (splitTotext(textprovincia) + '/' + splitTotext(textcanton) + '/' + splitTotext(textparroquia)).replace('/--Seleccione--', "");
        lugarNac.val(resultado);
    }
}

function fillLugarNacimiento() {
    $("#paciente_madrepcte_persona_provincia,#paciente_madrepcte_persona_canton,#paciente_madrepcte_persona_parroquia").change(getLugarNacimiento);
}

function enableAll(campos) {
    $(".has-error").removeClass("has-error");
    if (mode == "AGREGAR") {
        $('#menu6 .chosen-select').val('').trigger("chosen:updated");
        $('#menu6 .chosen-container').addClass('chosen-disabled');
    }
    enableFields(campos);
    enableFieldsWS(campos);
}

function clearFieldsWebservice() {
    primerApell.val("");
    segundoApell.val("");
    primerNom.val("");
    segundoNom.val("");
    fechaNac.val("");
    estcivil.val("");
    sexoMadre.val("");
    paisNac.val("").trigger("chosen:updated");
    provinciaNac.val("").trigger("chosen:updated");
    cantonNac.val("").trigger("chosen:updated");
    parroquiaNac.val("").trigger("chosen:updated");
    lugarNac.val('');
}

function clearVariables() {
    cantonnac_id = "";
    parroquianac_id = "";
    $("#madrepcte_foto").attr("src", '{{ asset('bundles/coregui/app/images/fotodefault.png') }}');
}

function changeRepresentante(){
    tipoIdent.val("");
    numeroIdent.val("");
    tipoIdent.attr("disabled", false);
    numeroIdent.attr("disabled", true);
    nivelinstruccion.val("").trigger("chosen:updated");
    autoidentetnica.val("").trigger("chosen:updated");
    madreparentesco.val("").trigger("chosen:updated");

   // enableAll(false);
    clearFieldsWebservice();
    clearVariables();
}